from sunways import Datasource
import sys, getopt
import json

DEFAULT_ADDRESSES = [1,2,3]

def main(argv):
    opts, args = getopt.getopt(sys.argv[1:],"i:")
    inverters_addresses = DEFAULT_ADDRESSES
    for opt, arg in opts:
        if opt in ('-i'):
            list_arg = json.loads(arg)
            inverters_addresses = list_arg

    datasource = Datasource(False)
    for inverter_address in inverters_addresses:
        print(f"----------------------------- Scanning inverter address {inverter_address} for data -------------------------------------------")
        single_values = {   "firmware": datasource.get_firmware(inverter_address), 
                                "serial_number": datasource.get_serial_number(inverter_address),
                                "date_time": datasource.get_date_time(inverter_address) }
        for k, v in single_values.items():
            if v:
                print(f"{k}: {v}")

        online_values = datasource.get_online_values(inverter_address)
        if online_values:
            print("Online Values:")
            for k,v in online_values.items():
                print(f"    {k:<4}: {v:.2f}")

main(sys.argv[1:])
